import { __decorate } from "tslib";
import { customElement, property } from 'lit-element';
import { style } from './vwc-dialog.css.js';
import { Dialog as MWCDialog } from '@material/mwc-dialog';
import { styles as mwcDialogStyles } from '@material/mwc-dialog/mwc-dialog.css.js';
import { style as styleCoupling } from '@vonage/vvd-style-coupling/mdc-vvd-coupling.css.js';
import '@vonage/vvd-core';
const iconTemplate = document.createElement('template');
iconTemplate.innerHTML = `
	<div id="dialog_icon">
		<slot name="icon"></slot>
</div>
`;
MWCDialog.styles = [styleCoupling, mwcDialogStyles, style];
let VWCDialog = class VWCDialog extends MWCDialog {
    firstUpdated() {
        super.firstUpdated();
        this.addDismissButton();
    }
    updated(_changedProperties) {
        var _a;
        super.updated(_changedProperties);
        if (!this.renderRoot.querySelector('#dialog_icon')) {
            (_a = this.renderRoot
                .querySelector('.mdc-dialog__surface')) === null || _a === void 0 ? void 0 : _a.prepend(iconTemplate.content.cloneNode(true));
        }
        if (_changedProperties.has('hideActions')) {
            const contentElement = this.renderRoot.querySelector('#content');
            if (contentElement) {
                _changedProperties.get('hideActions')
                    ? contentElement.classList.remove('last')
                    : contentElement.classList.add('last');
            }
        }
    }
    addDismissButton() {
        var _a, _b;
        const closeButtonWrapper = document.createElement('div');
        closeButtonWrapper.innerHTML = `<vwc-icon-button
								class="dismiss-button"
								icon="close-line"
								dense></vwc-icon-button>`;
        const closeButton = closeButtonWrapper.children[0];
        closeButton.addEventListener('click', () => {
            this.close();
        });
        (_b = (_a = this.shadowRoot) === null || _a === void 0 ? void 0 : _a.querySelector('.mdc-dialog__surface')) === null || _b === void 0 ? void 0 : _b.appendChild(closeButton);
    }
};
__decorate([
    property({
        attribute: 'close-button',
        type: Boolean,
        reflect: true
    })
], VWCDialog.prototype, "closeButton", void 0);
__decorate([
    property({ type: String, reflect: true, attribute: 'topPosition' })
], VWCDialog.prototype, "topPosition", void 0);
VWCDialog = __decorate([
    customElement('vwc-dialog')
], VWCDialog);
export { VWCDialog };
//# sourceMappingURL=vwc-dialog.js.map